@using Microsoft.Extensions.Options
@using Jones.AspNetCore.Bootstrap.Types
@using Jones.AspNetCore.Utils
@inherits ButtonBase

<button @attributes="@AdditionalAttributes" class="@Class" role="button" disabled="@Disabled" aria-disabled="@Disabled" @onclick="@OnClick">
    @if (IsLoading == true && !string.IsNullOrEmpty(ActualLoadingIcon))
    {
        <span>
            <i class="@ActualLoadingIcon"></i>
        </span>
    }
    else
    {
        if (!string.IsNullOrEmpty(Icon))
        {
            <span>
                <i class="@Icon"></i>
            </span>
        }
    }

    <CascadingValue Value="this" IsFixed="true">
        @ChildContent
    </CascadingValue>
</button>

@inject IOptions<ButtonConfig> Config;
@code{
    /// <summary>
    /// 获得/设置 Outline 样式
    /// </summary>
    [Parameter]
    public bool IsOutline { get; set; }

    /// <summary>
    /// 获得/设置 按钮颜色
    /// </summary>
    [Parameter]
    public ThemeColor? ThemeColor { get; set; } = Types.ThemeColor.Primary;
        
    /// <summary>
    /// 获得/设置 Size 大小
    /// </summary>
    [Parameter]
    public Size? Size { get; set; }
        
    protected string? Class => CssBuilder.Default("btn")
        .AddClass($"btn-outline-{ThemeColor?.GetDisplayName()}", ThemeColor != null && IsOutline)
        .AddClass($"btn-{ThemeColor?.GetDisplayName()}", ThemeColor != null && !IsOutline)
        .AddClass($"btn-{Size?.GetDisplayName()}", Size != null)
        .AddClass("disabled", IsDisabled)
        .AddClassFromAttributes(AdditionalAttributes)
        .Build();

    private string? ActualLoadingIcon => !string.IsNullOrEmpty(LoadingIcon)
        ? LoadingIcon
        : Config.Value.LoadingIcon;
}